﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace PropertyGrid_Sample
{
    public class Person : INotifyPropertyChanged
    {

        string _firstName;
        //		[Display(Name = "First Name", GroupName = "Information")]
        [Description("This property uses a TextBox as the default editor. This is a very long description. Testing the text wrapping feature!")]
        [ReadOnly(true)]
        [DefaultValue("Peshko")]
        public string FirstName
        {
            get { return _firstName; }
            set
            {
                _firstName = value;
                NotifyPropertyChanged("FirstName");
            }
        }

        int _age;
        [Category("Information")]
        [ReadOnly(true)]
        [Description("This property uses the XamNumericInput as the default editor.")]
        public int Age
        {
            get { return _age; }
            set
            {
                _age = value;
                NotifyPropertyChanged("Age");
            }
        }

        Color _favoriteColor;
        [Category("Information")]
        [ReadOnly(true)]
        [Description("This property uses the XamColorPicker as the default editor.")]
        public Color FavoriteColor
        {
            get { return _favoriteColor; }
            set
            {
                _favoriteColor = value;
                NotifyPropertyChanged("FavoriteColor");
            }
        }

        Brush _favoriteBrush;
        [Category("Information")]
        [ReadOnly(true)]
        [Description("This property uses the XamBrushEditor as the default editor.")]
        public Brush FavoriteBrush
        {
            get { return _favoriteBrush; }
            set
            {
                _favoriteBrush = value;
                NotifyPropertyChanged("FavoriteBrush");
            }
        }

        DateTime _birthday;
        [Category("Dates")]
        [ReadOnly(true)]
        [Description("Birthday")]
        public DateTime Birthday
        {
            get { return _birthday; }
            set
            {
                _birthday = value;
                NotifyPropertyChanged("Birthday");
            }
        }

        ReadOnlyCollection<double> _bankBalances;
        [Description("Bank account balances.")]
        [DisplayName("Money in the bank")]
        public ReadOnlyCollection<double> BankBalances
        {
            get { return _bankBalances; }
            set
            {
                _bankBalances = value;
                NotifyPropertyChanged("BankBalances");
            }
        }

        public void ResetFirstName()
        {
            FirstName = "dasdasd";
        }


        public Person()
        {
            FirstName = "Ivan";
            Age = 22;
            FavoriteColor = new SolidColorBrush(Colors.Red).Color;
            Birthday = new DateTime(1999, 5, 5);
            BankBalances = new List<double>() { 1.5, 5.6, 7.8 }.AsReadOnly();
            List<string> ts = new List<string>();
            
        
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void NotifyPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }
        


        
    }
}
